//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBLoadFull2DButton extends MSBListButton;

var MSB2DCharEdController CC;
var string loadName;

event PostBeginPlay()
{
local int i;
super.PostBeginPlay();
CC=MSB2DCharEdController(M);
for (i=0;i<M.Save2DCharacters.length;i++)
  ButtonList[i]="MSBPropertyButtons.MSBPropertyButtonAssign";
}

function LeftBtn(Canvas C)                      //spawns subButtons
{
local int i;
super.LeftBtn(C);

for (i=currentpage*0;i<maxButtons; i++)
  {
    MSBPropertyButton(ListButton[i]).Property="LoadName";
    MSBPropertyButton(ListButton[i]).BtnName=M.Save2DCharacters[i];
    MSBPropertyButton(ListButton[i]).Parent=self;
  }
}

event Trigger(Actor Other, Pawn EventInstigator)
{
local MSB2DCharacterSave char;
local MSBSpritePawn sP;
local int anims;

char=Level.Game.LoadDataObject(class'MSB2DCharacterSave',loadName,"MSB2DChar"$loadName);
sP=CC.myReferencePawn;

Log("Loading...");

CC.States[0].Material=char.Idle;
CC.States[0].Trigger(self,none);

CC.States[1].Material=char.Move;
CC.States[1].Trigger(self,none);

for (anims=0;anims<char.Animations.length;anims++)
 {
 Log(char.Animations[anims]);
 CC.Animations[anims]=char.Animations[anims];
 }

CC.States[2].Material=char.animations[0];
CC.States[2].Trigger(self,none);
}



DefaultProperties
{
tooltip="Load a CharacterPart"
}
