class MSBScriptNode extends ScriptedSequence;

var ScriptedSequence OurNextScript;
var string Description,
           SelectText;

var MSBSpritePawn sP;  // for MSBSpritePawn Control -> see MSBSpriteNode

function initialize()
{
 local Action_ChangeScript cs;
 local int l;

 //remove all Actions
 if (Actions.Length>0)
  Actions.Remove(0,Actions.length);

 // initialize all linked sequences - taken out, done when starting the movie

 //fill sequence with Node-specific Actions
 fillSequence();

 // set changeScript Action at the end;
 cs= new(None) class'Action_CHANGESCRIPT';
 cs.NextScript=OurNextScript;
 l=Actions.Length;
 Actions[l]=cs;

}

function fillSequence();

function Reset()
{
super.Reset();
// removed, for Loops and stuff!
// if (OurNextScript!=None && OurNextScript.IsA('MSBScriptNode'))
//  OurNextScript.Reset();

}

function Execute(string Data); //for key Input and stuff...

defaultproperties
{
 bNavigate=false
 bStatic=False
 OurNextScript=None
 bHidden=true
 bPathColliding=False

 Description="optional - fill in some Description here"
 ScriptControllerClass=ScriptedController
}


