class MSBAniKey extends Object;

var rotator BoneRotation;
var int BoneNumber;
var float TimeStamp;
var Actor KeyActor;
var name RigBoneName[63];
var name FaceBone[26];

function initialize()
{
BoneRotation=GetRelBoneRotation();
}

function rotator GetRelBoneRotation()       // recalculates absolute bonerotations to relative bonerotations.
{
local coords iParent, iChild;
local vector Xr,Yr,Zr;
local rotator RelRot;

if (KeyActor.IsA('MSBPawn'))
 {
 iParent=GetParentBoneCoordsUTSkel();
 iChild=GetBoneCoordsUTSkel();
 }
if (KeyActor.IsA('MSBFullRig'))
 {
  GetFullRigRelBoneRotation(BoneNumber,iParent,iChild);
 }

 Xr.x=iParent.XAxis dot iChild.XAxis;
 Xr.y=iParent.XAxis dot iChild.YAxis;
 Xr.Z=iParent.XAxis dot iChild.ZAxis;

 Yr.x=iParent.YAxis dot iChild.XAxis;
 Yr.y=iParent.YAxis dot iChild.YAxis;
 Yr.Z=iParent.YAxis dot iChild.ZAxis;

 Zr.x=iParent.ZAxis dot iChild.XAxis;
 Zr.y=iParent.ZAxis dot iChild.YAxis;
 Zr.Z=iParent.ZAxis dot iChild.ZAxis;

 RelRot=OrthoRotation(Xr,Yr,Zr);
 return RelRot;
}


function vector GetBoneLocation()
{
if (KeyActor.IsA('MSBFullRig'))
  return((KeyActor.GetBoneCoords(RigBoneName[BoneNumber])).Origin);
if (KeyActor.IsA('MSBPawn'))
  return(GetBoneCoordsUTSkel().Origin);
}

function rotator GetAniBoneRotation()
{
if (KeyActor.IsA('MSBFullRig'))
  return(KeyActor.GetBoneRotation(RigBoneName[BoneNumber]));
if (KeyActor.IsA('MSBPawn'))
  return(GetBoneRotationUTSkel());

}

function RotateBone (rotator delta)
{
BoneRotation=BoneRotation+delta;
changeBoneRotation();
}

function changeBoneRotation()
{
if (KeyActor.IsA('MSBFullRig'))
  KeyActor.SetBoneRotation(RigBoneName[BoneNumber],BoneRotation);
else if (KeyActor.IsA('MSBPawn'))
  changeBoneRotationUTSkel();
}

function changeBoneRotationUTSkel()
{
if (BoneNumber==0) KeyActor.setBoneRotation('Bip01', BoneRotation);

if (BoneNumber==1) KeyActor.setBoneRotation('Bip01 Pelvis', BoneRotation);
if (BoneNumber==2) KeyActor.setBoneRotation('bip01 Spine', BoneRotation);
if (BoneNumber==3) KeyActor.setBoneRotation('bip01 Spine1', BoneRotation);
if (BoneNumber==4) KeyActor.setBoneRotation('bip01 Spine2', BoneRotation);
if (BoneNumber==5) KeyActor.setBoneRotation('Bip01 Neck', BoneRotation);

if (BoneNumber==6) KeyActor.setBoneRotation('Bip01 R Clavicle', BoneRotation);
if (BoneNumber==7) KeyActor.setBoneRotation('Bip01 R UpperArm', BoneRotation);
if (BoneNumber==8) KeyActor.setBoneRotation('Bip01 R Forearm', BoneRotation);
if (BoneNumber==9) KeyActor.setBoneRotation('Bip01 R Hand', BoneRotation);
if (BoneNumber==10) KeyActor.setBoneRotation('Bip01 R Finger', BoneRotation);
if (BoneNumber==11) KeyActor.setBoneRotation('Bone_weapon', BoneRotation);

if (BoneNumber==12) KeyActor.setBoneRotation('Bip01 L Clavicle', BoneRotation);
if (BoneNumber==13) KeyActor.setBoneRotation('Bip01 L UpperArm', BoneRotation);
if (BoneNumber==14) KeyActor.setBoneRotation('Bip01 L Forearm', BoneRotation);
if (BoneNumber==15) KeyActor.setBoneRotation('Bip01 L Hand', BoneRotation);
if (BoneNumber==16) KeyActor.setBoneRotation('Bip01 L Finger', BoneRotation);

if (BoneNumber==17) KeyActor.setBoneRotation('bip01 R Thigh', BoneRotation);
if (BoneNumber==18) KeyActor.setBoneRotation('Bip01 R Calf', BoneRotation);
if (BoneNumber==19) KeyActor.setBoneRotation('Bip01 R Foot', BoneRotation);
if (BoneNumber==20) KeyActor.setBoneRotation('Bip01 R Toe0', BoneRotation);

if (BoneNumber==21) KeyActor.setBoneRotation('bip01 L Thigh', BoneRotation);
if (BoneNumber==22) KeyActor.setBoneRotation('Bip01 L Calf', BoneRotation);
if (BoneNumber==23) KeyActor.setBoneRotation('Bip01 L Foot', BoneRotation);
if (BoneNumber==24) KeyActor.setBoneRotation('Bip01 L Toe0', BoneRotation);

if (BoneNumber==25) KeyActor.setBoneRotation('Bip01 Head', BoneRotation);
}

function coords GetBoneCoordsUTSkel()
{
if (BoneNumber==0) return(KeyActor.getBoneCoords('Bip01'));

if (BoneNumber==1) return(KeyActor.getBoneCoords('Bip01 Pelvis'));
if (BoneNumber==2) return(KeyActor.getBoneCoords('bip01 Spine'));
if (BoneNumber==3) return(KeyActor.getBoneCoords('bip01 Spine1'));
if (BoneNumber==4) return(KeyActor.getBoneCoords('bip01 Spine2'));
if (BoneNumber==5) return(KeyActor.getBoneCoords('Bip01 Neck'));

if (BoneNumber==6) return(KeyActor.getBoneCoords('Bip01 R Clavicle'));
if (BoneNumber==7) return(KeyActor.getBoneCoords('Bip01 R UpperArm'));
if (BoneNumber==8) return(KeyActor.getBoneCoords('Bip01 R Forearm'));
if (BoneNumber==9) return(KeyActor.getBoneCoords('Bip01 R Hand'));
if (BoneNumber==10) return(KeyActor.getBoneCoords('Bip01 R Finger'));
if (BoneNumber==11) return(KeyActor.getBoneCoords('Bone_weapon'));

if (BoneNumber==12) return(KeyActor.getBoneCoords('Bip01 L Clavicle'));
if (BoneNumber==13) return(KeyActor.getBoneCoords('Bip01 L UpperArm'));
if (BoneNumber==14) return(KeyActor.getBoneCoords('Bip01 L Forearm'));
if (BoneNumber==15) return(KeyActor.getBoneCoords('Bip01 L Hand'));
if (BoneNumber==16) return(KeyActor.getBoneCoords('Bip01 L Finger'));

if (BoneNumber==17) return(KeyActor.getBoneCoords('bip01 R Thigh'));
if (BoneNumber==18) return(KeyActor.getBoneCoords('Bip01 R Calf'));
if (BoneNumber==19) return(KeyActor.getBoneCoords('Bip01 R Foot'));
if (BoneNumber==20) return(KeyActor.getBoneCoords('Bip01 R Toe0'));

if (BoneNumber==21) return(KeyActor.getBoneCoords('bip01 L Thigh'));
if (BoneNumber==22) return(KeyActor.getBoneCoords('Bip01 L Calf'));
if (BoneNumber==23) return(KeyActor.getBoneCoords('Bip01 L Foot'));
if (BoneNumber==24) return(KeyActor.getBoneCoords('Bip01 L Toe0'));

if (BoneNumber==25) return(KeyActor.getBoneCoords('Bip01 Head'));
}

function coords GetParentBoneCoordsUTSkel()
{
if (BoneNumber==0) return(KeyActor.getBoneCoords('Bip01'));
if (BoneNumber==1) return(KeyActor.getBoneCoords('Bip01'));

if (BoneNumber==2) return(KeyActor.getBoneCoords('Bip01 Pelvis'));
if (BoneNumber==3) return(KeyActor.getBoneCoords('bip01 Spine'));
if (BoneNumber==4) return(KeyActor.getBoneCoords('bip01 Spine1'));
if (BoneNumber==5) return(KeyActor.getBoneCoords('bip01 Spine2'));
if (BoneNumber==6) return(KeyActor.getBoneCoords('Bip01 Neck'));

if (BoneNumber==7) return(KeyActor.getBoneCoords('Bip01 R Clavicle'));
if (BoneNumber==8) return(KeyActor.getBoneCoords('Bip01 R UpperArm'));
if (BoneNumber==9) return(KeyActor.getBoneCoords('Bip01 R Forearm'));
if (BoneNumber==10) return(KeyActor.getBoneCoords('Bip01 R Hand'));
if (BoneNumber==11) return(KeyActor.getBoneCoords('Bip01 R Hand'));

if (BoneNumber==12) return(KeyActor.getBoneCoords('Bip01 Neck'));
if (BoneNumber==13) return(KeyActor.getBoneCoords('Bip01 L Clavicle'));
if (BoneNumber==14) return(KeyActor.getBoneCoords('Bip01 L UpperArm'));
if (BoneNumber==15) return(KeyActor.getBoneCoords('Bip01 L Forearm'));
if (BoneNumber==16) return(KeyActor.getBoneCoords('Bip01 L Hand'));

if (BoneNumber==17) return(KeyActor.getBoneCoords('Bip01 Pelvis'));
if (BoneNumber==18) return(KeyActor.getBoneCoords('bip01 R Thigh'));
if (BoneNumber==19) return(KeyActor.getBoneCoords('Bip01 R Calf'));
if (BoneNumber==20) return(KeyActor.getBoneCoords('Bip01 R Foot'));

if (BoneNumber==21) return(KeyActor.getBoneCoords('Bip01 Pelvis'));
if (BoneNumber==22) return(KeyActor.getBoneCoords('bip01 L Thigh'));
if (BoneNumber==23) return(KeyActor.getBoneCoords('Bip01 L Calf'));
if (BoneNumber==24) return(KeyActor.getBoneCoords('Bip01 L Foot'));

if (BoneNumber==25) return(KeyActor.getBoneCoords('Bip01 Neck'));
}

function rotator GetBoneRotationUTSkel()
{
if (BoneNumber==0) return(KeyActor.getBoneRotation('Bip01'));

if (BoneNumber==1) return(KeyActor.getBoneRotation('Bip01 Pelvis'));
if (BoneNumber==2) return(KeyActor.getBoneRotation('bip01 Spine'));
if (BoneNumber==3) return(KeyActor.getBoneRotation('bip01 Spine1'));
if (BoneNumber==4) return(KeyActor.getBoneRotation('bip01 Spine2'));
if (BoneNumber==5) return(KeyActor.getBoneRotation('Bip01 Neck'));

if (BoneNumber==6) return(KeyActor.getBoneRotation('Bip01 R Clavicle'));
if (BoneNumber==7) return(KeyActor.getBoneRotation('Bip01 R UpperArm'));
if (BoneNumber==8) return(KeyActor.getBoneRotation('Bip01 R Forearm'));
if (BoneNumber==9) return(KeyActor.getBoneRotation('Bip01 R Hand'));
if (BoneNumber==10) return(KeyActor.getBoneRotation('Bip01 R Finger'));
if (BoneNumber==11) return(KeyActor.getBoneRotation('Bone_weapon'));

if (BoneNumber==12) return(KeyActor.getBoneRotation('Bip01 L Clavicle'));
if (BoneNumber==13) return(KeyActor.getBoneRotation('Bip01 L UpperArm'));
if (BoneNumber==14) return(KeyActor.getBoneRotation('Bip01 L Forearm'));
if (BoneNumber==15) return(KeyActor.getBoneRotation('Bip01 L Hand'));
if (BoneNumber==16) return(KeyActor.getBoneRotation('Bip01 L Finger'));

if (BoneNumber==17) return(KeyActor.getBoneRotation('bip01 R Thigh'));
if (BoneNumber==18) return(KeyActor.getBoneRotation('Bip01 R Calf'));
if (BoneNumber==19) return(KeyActor.getBoneRotation('Bip01 R Foot'));
if (BoneNumber==20) return(KeyActor.getBoneRotation('Bip01 R Toe0'));

if (BoneNumber==21) return(KeyActor.getBoneRotation('bip01 L Thigh'));
if (BoneNumber==22) return(KeyActor.getBoneRotation('Bip01 L Calf'));
if (BoneNumber==23) return(KeyActor.getBoneRotation('Bip01 L Foot'));
if (BoneNumber==24) return(KeyActor.getBoneRotation('Bip01 L Toe0'));

if (BoneNumber==25) return(KeyActor.getBoneRotation('Bip01 Head'));
}

function GetFullRigRelBoneRotation(int BoneCount, out coords iParent, out coords iChild)       // recalculates absolute bonerotations to relative bonerotations.
{
local int parent;

parent=BoneCount-1;

 if (BoneCount%4==0) //some bones have special parents!
   {
   if (BoneCount/4==0)
     parent=6;
   if (BoneCount/4==1)
     parent=4;
   if (BoneCount/4==2)
     parent=4;
   if (BoneCount/4==3)
     parent=4;
   if (BoneCount/4==4)
     parent=6;
   if (BoneCount/4==5)
     parent=6;
   if (BoneCount/4==6)
     parent=19;
   if (BoneCount/4==7)
     parent=19;
   if (BoneCount/4==8)
     parent=19;
   if (BoneCount/4==9)
     parent=23;
   if (BoneCount/4==10)
     parent=23;
   if (BoneCount/4==11)
     parent=23;
   }
// recalculate from absolute Rotation to Skeletons relative Rotations
 iParent=KeyActor.GetBoneCoords(RigBoneName[parent]);
 iChild=KeyActor.GetBoneCoords(RigBoneName[BoneCount]);
}

defaultproperties
{
// *****************************************************************************
// *following only works for full rigs with respect to the naming convention:  *
// *****************************************************************************
    RigBoneName(0)=neck                               // these are the Malcolm UT2003 Intro RigBoneNames
    RigBoneName(1)=head

    RigBoneName(4)=pelivs
    RigBoneName(5)=back_low
    RigBoneName(6)=back_high

    RigBoneName(8)=l_hip
    RigBoneName(9)=l_knee
    RigBoneName(10)=l_ankle
    RigBoneName(11)=l_toe

    RigBoneName(12)=r_hip
    RigBoneName(13)=r_knee
    RigBoneName(14)=r_ankle
    RigBoneName(15)=r_toe

    RigBoneName(16)=l_clav
    RigBoneName(17)=l_shoulder
    RigBoneName(18)=l_elbow
    RigBoneName(19)=l_wrist


    RigBoneName(20)=r_clav
    RigBoneName(21)=r_shoulder
    RigBoneName(22)=r_elbow
    RigBoneName(23)=r_wrist

    RigBoneName(24)=lh_0_1  //thumb
    RigBoneName(25)=lh_0_2  //thumb
    RigBoneName(26)=lh_0_3  //thumb

    RigBoneName(28)=lh_1_1
    RigBoneName(29)=lh_1_2
    RigBoneName(30)=lh_1_3

    RigBoneName(32)=lh_2_1
    RigBoneName(33)=lh_2_2
    RigBoneName(34)=lh_2_3

    RigBoneName(36)=lh_3_1
    RigBoneName(37)=lh_3_2
    RigBoneName(38)=lh_3_3

    RigBoneName(40)=lh_4_1
    RigBoneName(41)=lh_4_2
    RigBoneName(42)=lh_4_3

    RigBoneName(44)=rh_0_1  //thumb
    RigBoneName(45)=rh_0_2  //thumb
    RigBoneName(46)=rh_0_3  //thumb

    RigBoneName(48)=rh_1_1
    RigBoneName(49)=rh_1_2
    RigBoneName(50)=rh_1_3

    RigBoneName(52)=rh_2_1
    RigBoneName(53)=rh_2_2
    RigBoneName(54)=rh_2_3

    RigBoneName(56)=rh_3_1
    RigBoneName(57)=rh_3_2
    RigBoneName(58)=rh_3_3

    RigBoneName(60)=rh_4_1
    RigBoneName(61)=rh_4_2
    RigBoneName(62)=rh_4_3

    FaceBone(0)=f_lips_top
    FaceBone(1)=f_lips_top_r
    FaceBone(2)=f_lips_top_l
    FaceBone(3)=f_lips_left
    FaceBone(4)=f_lips_right
    FaceBone(5)=f_lips_btm_r
    FaceBone(6)=f_lips_btm_l
    FaceBone(7)=f_lips_btm

    FaceBone(8)=f_jaw
    FaceBone(9)=f_cheek_l
    FaceBone(10)=f_cheek_r

    FaceBone(11)=f_r_brow_out
    FaceBone(12)=f_r_brow_in
    FaceBone(13)=f_l_brow_out
    FaceBone(14)=f_l_brow_in

    FaceBone(15)=f_l_eye
    FaceBone(16)=f_r_eye
    FaceBone(17)=f_eyelid_l
    FaceBone(18)=f_eyelid_r
}
