//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBCreateSpritePawn extends MSB3DSpawnButton;

function LeftBtnFinished(Canvas C)
{
local MSBScriptNodeButton ScNodeBtn;
local MSBNodeButton SpNodeBtn;

local MSBSpriteNode S;
local MSBSpritePawn sP;

sP=MSBSpritePawn(SpawnActor);

//Spawn a MSBSpriteNode
S=Spawn(class'MSBActions.MSBSpriteNode');
S.BasePawn=sP;
S.initialLocation=sP.Location;
S.initialRotation=sP.Rotation;

//Spawn a MSBSpriteNode Btn - aka a Node Button with a MSBSpriteNode as Order
SpNodeBtn=Spawn(class'MSBCode.MSBNodeButton');
SpNodeBtn.Order=S;
SpNodeBtn.BtnName="SpriteRoot";
SpNodeBtn.xPos=Mouse.xPos+40;
SpNodeBtn.yPos=Mouse.yPos+40;
SpNodeBtn.col.R=100;
SpNodeBtn.col.G=100;

//SpNodeBtn.NodeIn.Destroy();

// Spawn a MSBScriptNodeBtn and Link it to the SpriteRoot
ScNodeBtn=Spawn(class'MSBCode.MSBScriptNodeButton');
ScNodeBtn.xPos=Mouse.xPos+30;

//Link the MSBSpriteNode to the MSBScriptNode
ScNodeBtn.Order.OurNextScript=S;
ScNodeBtn.NodeOut.ChildNode=SpNodeBtn.NodeIn;
SpNodeBtn.NodeIn.ParentNode=ScNodeBtn.NodeOut;

//assign MSBPropertyButtons to SpriteMSBNodeButton
SpNodeBtn.ButtonList[0]="MSBPropertyButtons.MSBPropertyButtonHideLinks";
SpNodeBtn.Properties[0]="HideLinks";
SpNodeBtn.ButtonList[1]="MSBPropertyButtons.MSBPropertyButtonShowLinks";
SpNodeBtn.Properties[1]="ShowLinks";
sP.SetPhysics(PHYS_Falling);

//make ScriptRoot invisible
M.myHUD.RemoveHudOverlay(spNodeBtn.NodeIn);
M.myHUD.RemoveHudOverlay(ScNodeBtn);
M.myHUD.RemoveHudOverlay(ScNodeBtn.NodeOut);

super.LeftBtnFinished(C);
}

DefaultProperties
{
tooltip1="Spawn a MSBSpritePawn"
tooltip2="Place MSBSpritePawn"

SpawnActorClassName="MSBObjects.MSBSpritePawn"
}
