class MSBProjector extends MSBActor;

var DynamicProjector myProjector;
var string DecalMaterial;
var() bool		Clip;

event PostBeginPlay()
{
super.PostBeginPlay();
myProjector=Spawn(class'DynamicProjector',self,,self.location,self.rotation);
}

function Tick(float DeltaTime)
{
super.Tick(DeltaTime);

if (string(myProjector.ProjTexture)!=DecalMaterial)
  myProjector.ProjTexture=Texture(DynamicLoadObject(DecalMaterial,class'Texture'));

if (Clip && !myProjector.bClipBSP)
  {
  myProjector.bClipBSP=true;
  myProjector.bClipStaticMesh=true;
  myProjector.FOV=1;
  }

myProjector.SetLocation(Location);
myProjector.SetRotation(Rotation);
}

event Destroyed()
{
super.Destroyed();
myProjector.Destroy();
}

defaultproperties
{
ButtonList(5)="MSBPropertyButtons.MSBPropertyButtonText"
Properties(5)="DecalMaterial"
ButtonList(6)="MSBPropertyButtons.MSBPropertyButtonAttachToBone"
Properties(6)="Dummy"

DecalMaterial="MovieSandboxTextures.BrushTexture"

bDisplayed=false

DrawType=DT_StaticMesh
StaticMesh=StaticMesh'MoviesandboxMeshes.helperMeshes.arrowWhite'
Skins(0)=Material'MovieSandboxTextures.red'
Drawscale=3
bStatic=false
bNoDelete=false
bHidden=false

Physics=PHYS_None

bDirectional=True

CollisionRadius=16.0
CollisionHeight=16.0

bUseCylinderCollision=true
bCollideActors=True
bBlockActors=False
bCollideWorld=True
bProjTarget=True
Texture=S_LookTarget
}
