//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBPropertyButtonPoseList extends MSBPropertyButton;

var array<String> ButtonList;
var array<String> Properties;
var array<MSBGuiOverlay> ListButton;

function LeftBtn(Canvas C)
{
local int i;
super.LeftBtn(C);

//for (i=0;i<MSBPropertyButtonPad(Parent).ListButton.length;i++)
//  if(MSBPropertyButtonPad(Parent).ListButton[i]!=self)
//    MSBPropertyButtonPad(Parent).ListButton[i].deSelect();

for (i=0;i<M.SavePoses.length; i++)
  {
    ListButton[i]=Spawn(class'MSBPropertyButtonAssign',self,,M.Location);
    ListButton[i].xPos=xpos+width;
     if (i>0)
      {                          //horizontal alignment
      ListButton[i].yPos=ListButton[i-1].ypos+ListButton[i-1].height+2;
      if (ListButton[i].yPos+ListButton[i].height>C.ClipY && ListButton[i].height<60)
        ListButton[i].ypos=yPos-(i*ListButton[i].height+height+2);
      }
    else
      ListButton[i].yPos=ypos;
    ListButton[i].SubLevel=SubLevel+1;
    MSBPropertyButton(ListButton[i]).Parent=self;
    MSBPropertyButton(ListButton[i]).BtnName=M.SavePoses[i];
  }
LeftBtnFinished(C);
}

event Trigger(Actor Other,Pawn EventInstigator)
{
local int i;

for (i=0;i<ListButton.length;i++)
  if (Other==ListButton[i])
    {
    if (Parent.IsA('MSBPropertyButtonPad'))
      MSBPropertyButtonPad(Parent).AssignPoseToButton(self,i);
    if (Parent.IsA('MSBNodeButton'))
      MSBNodeButton(Parent).Order.SetPropertyText(Property,M.SavePoses[i]);
    }
}

function MouseOver(Canvas C)
{
super.MouseOver(C);
C.SetPos(xpos+width,ypos);
if (Parent.IsA('MSBNodeButton'))
  C.DrawText(MSBNodeButton(Parent).Order.GetPropertyText(Property));
}


DefaultProperties
{
//width=32
Col=(R=128,G=64,B=64)
}
