//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBVoxelEdPartSaveButton extends MSBListButton;

#exec texture Import File=Textures\savePart.tga Name=savePart_Icon Mips=Off Alpha=1

var MSBVoxelEdController CC;
var string saveName;

event PostBeginPlay()
{
local int i;
super.PostBeginPlay();
CC=MSBVoxelEdController(M);

for (i=0;i<M.saveCharParts.length+1;i++)
  {
  Log(M.saveCharParts.length);
  Log(M.saveCharParts[i]);
  ButtonList[i]="MSBPropertyButtons.MSBPropertyButtonText";
  }


}



function LeftBtn(Canvas C)                      //spawns subButtons
{
local int i;
super.LeftBtn(C);

for (i=currentpage*8;i<maxButtons;i++)
  {
    MSBPropertyButton(ListButton[i]).Property="saveName";
    MSBPropertyButton(ListButton[i]).Parent=self;
    MSBPropertyButton(ListButton[i]).BtnName="createNew";
    if (i<ButtonList.length-1)
      MSBPropertyButton(ListButton[i]).BtnName=M.SaveCharParts[i];
  }
}

event Trigger(Actor Other, Pawn EventInstigator)
{
local MSBBlockCloud cloud;
local MSBMasterBlock Master;
local int i;

Master=CC.Master;
cloud=Level.Game.CreateDataObject(class'MSBBlockCloud',saveName,"CharacterParts");
for (i=0;i<Master.S.length;i++)
  {
  cloud.BlockRelLocation[i]=Master.S[i].RelativeLocation << Master.Rotation;
  Log(Master.S[i].RelativeLocation);
  cloud.Col[i]=ColorModifier(Master.S[i].Skins[0]).Color;
  cloud.drawScale[i]=Master.S[i].DrawScale;
  }
Level.Game.SavePackage("CharacterParts");
//update SaveParts List
for (i=0;i<ListButton.Length;i++)
  if (Other==ListButton[i] && i< ListButton.Length)
    M.SaveCharParts[i]=saveName;

M.SaveGeneralConfig();
}


DefaultProperties
{
tooltip="Save a CharacterPart"
Mat=savePart_Icon
}
