class MSBBrushShader extends MSBVoxelShader;

var Material BrushMat;
var ColorModifier colMat;

var int texPointer;
var float currTime,changeTime;
var bool bBlack;
var float drawScale;
var PlayerController PC;
var vector oldlocation;

//eyes blinking
var int blinkCount;
var int blinkLevel;

function initShader(color col)
{
colMat=new class'ColorModifier';
colMat.Color=col;
colMat.Material=BrushMat;
}

function Shade(float DeltaTime, color col)
{
super.Shade(DeltaTime,col);

if (PC==None)
  PC=Parent.Level.GetLocalPlayerController();

if (Parent.DrawType!=DT_Sprite)
  {
  Parent.SetDrawType(DT_Sprite);
  Parent.Texture=colMat;
  }

if (currTime>=changeTime && VSize((PC.ViewTarget.Location-Parent.Location)-oldlocation)>0.01)
  {
  currTime=0;
  if (texpointer>2)
    texpointer=0;
  Parent.SetDrawScale(drawScale* VSize(Parent.DrawScale3D*2)*(0.5+Frand()));
  }

currTime+=DeltaTime;
oldlocation=PC.ViewTarget.Location-Parent.Location;
}

defaultproperties
{
BrushMat=Material'MoviesandboxTextures.BrushTexture'
changeTime=0.15
drawScale=0.02
}
