class MSBAction_SetCamera extends ScriptedAction;

var Actor ViewActor;
var bool ShakyCam;
var Actor LookTarget;
var float FOV;
var PlayerController pc;

function bool InitActionFor(ScriptedController C)
{
 local MSBCamera MSC;

 foreach C.AllActors (class'PlayerController', pc)
   break;

 if (MSBCamera(ViewActor)!=None)
  {
  MSC=MSBCamera(ViewActor);
  if (LookTarget!=None)
    MSC.SetRotation(rotator(LookTarget.Location-MSC.Location));
  MSC.FOV=FOV;
  if (MSC.FOV>0)
    pc.SetFOV(MSC.FOV);
  MSC.bShaky=ShakyCam;
  if (LookTarget!=None)
    MSC.ViewTarget=LookTarget;
  }
 pc.SetViewTarget(ViewActor);
 return false;

}


