class MSBLipSyncUdpLink extends UdpLink
config(user);

var () int iPort;   // server port number
var IpAddr Addr;
var () Pawn Pawn;

simulated function InitUdpLink()   //  Basic UDP Setup
{
  ReceiveMode = RMODE_Manual; // We are manually catching incomming data
  LinkMode = MODE_Binary;      // We expect to receive data in Text format

  GetLocalIp(Addr);
  addr.port = iport;
  BindPort(addr.port, true);
  SaveConfig();
  foreach AllActors (class'Pawn',Pawn,'Moderator') // Link to Moderator
   if (Pawn!=None) break;
}

function Timer() // after a set amount of time, mouth switches back to "closed, normal"
{
Log("endtalk!");
//Pawn.setMouth(1);
}

simulated event Tick(float DeltaTime)
{
local string myText;
local float value;

if (Pawn!=None)            //if we have a moderator whose lips to move
 {
  ReadText(Addr,myText);   // get Text from the UDP port
  myText=Left(myText,6);   // crop because of shitty formatting in vvvv
  value=float(myText);     // value=the volume that vvvv sends through FFT
  if (Value>0.4)
    {
//    Pawn.setMouth(FRand()*2+2);       //randomly set a mouth gesture
    SetTimer(0.2, false);             // and return to normal after 0.2 seconds
    }
  }
}


defaultproperties
{
     iPort=4444
}

