//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBPropertyButtonMoveRelative extends MSBPropertyButton;
var bool bDragged;

var vector chgLoc,
           xAxis,
           yAxis,
           zAxis;

var float oldX,
          oldY;

var bool bShift;

var EPhysics OldPhysics;

function InitButton(Canvas C)
{
super.initButton(C);
}

function Render(Canvas C)
{
super.Render(C);
if (bEnabled)
 {
  if (bDragged)
    {
    if (bShift)
      chgLoc.Z=-(Mouse.yPos-oldY);
    else
      chgLoc=yAxis*(Mouse.xPos-oldX)-xAxis*(Mouse.yPos-oldY);

    //Parent.SetRelativeLocation(Parent.Location+chgLoc);
    Parent.SetRelativeLocation(Parent.relativeLocation+chgLoc);
    Mouse.xPos=oldX;
    Mouse.yPos=oldY;
    }

 if (hasClicked && Mouse.btnOne)
    {
    hasClickedAgain=true;
    LeftBtnFinished(C);
    hasClickedAgain=false;
    }
 if (hasClicked && Mouse.bShiftDown && !bShift)
    PressShift(C);
 }

if (!Mouse.bShiftDown)
 bShift=false;
}

function PressShift(Canvas C)
{
bShift=true;
}



function LeftBtn(Canvas C)
{
super.LeftBtn(C);
bDragged=true;
Mouse.bHitActors=false;
oldX=Mouse.xPos;
oldY=Mouse.yPos;
OldPhysics=Parent.Physics;
Parent.SetPhysics(PHYS_None);
GetAxes(M.Rotation,xAxis,yAxis,zAxis);
xAxis.Z=0;
yAxis.Z=0;
}

function LeftBtnFinished(Canvas C)
{
local int i;
local MSBNodeButton N;

HasClicked=false;
//enable all other buttons after second press
for (i=0;i<M.myHud.Overlays.Length-1;i++)
  if (M.myHud.Overlays[i].IsA('MSBGuiOverlay'))
    MSBGuiOverlay(M.myHud.Overlays[i]).bEnabled=true;

Mouse.btnOne=false;
bDragged=false;

//if we move a Pawn, then set InitialLocation in depending MSBRootNode
Parent.SetPhysics(OldPhysics);
if (Parent.IsA('Pawn'))
  {
  foreach AllActors(class'MSBNodeButton',N)
    if (MSBRootNode(N.Order).BasePawn==Pawn(Parent))
       MSBRootNode(N.Order).initialLocation=Parent.Location;
  }
if (Parent.IsA('MSBSpritePawn'))
  {
  foreach AllActors(class'MSBNodeButton',N)
    if (MSBSpriteNode(N.Order).BasePawn==MSBSpritePawn(Parent))
      MSBSpriteNode(N.Order).initialLocation=Parent.Location;
   }

if (Parent.IsA('MSBCamera'))
  MSBCamera(Parent).initialLocation=Parent.Location;

Mouse.bHitActors=true;
}

DefaultProperties
{
BtnName="MoveRel"
}
