class MSBPropertyButtonPad extends MSBPropertyButton;

#exec texture Import File=Textures\pad.tga Name=pad_Icon Mips=Off Alpha=1

var array<String> ButtonList;
var class<MSBGuiOverlay> ButtonClass;
var array<MSBGuiOverlay> ListButton;

event iniPadButton()
{
local int i;
Log("Sublevel from PropertyButtonPad:"@SubLevel+1);

for (i=0;i<Buttonlist.Length; i++)
  {
    ButtonClass = class<MSBGuiOverlay>(DynamicLoadObject(ButtonList[i], class'Class'));
    ListButton[i]=Spawn(ButtonClass,self,,M.Location);
    ListButton[i].SubLevel=SubLevel+1;
    ListButton[i].xPos=xPos+width;
    ListButton[i].yPos=ypos+i*(ListButton[i].height+6);
    ListButton[i].BtnName=string(i+1);
    if (i==4)
      {
      ListButton[i].xPos=xPos;
      ListButton[i].yPos=yPos-16;
      }
    if (i==6)
      {
      ListButton[i].xPos=xPos;
      ListButton[i].yPos=yPos-34;
      }
    if (i==5)
      {
      ListButton[i].xPos=xPos+width-96;
      ListButton[i].yPos=yPos-16;
      }
    if (i==7)
      {
      ListButton[i].xPos=xPos+width-96;
      ListButton[i].yPos=yPos-34;
      }
    if (i>7)
      {
      ListButton[i].xPos=xPos+width-128;
      ListButton[i].yPos=yPos+200+(i-7)*(ListButton[i].height+6);;
      }

    if (i>11)
      {
      ListButton[i].xPos=xPos-ListButton[i].width*2;
      ListButton[i].yPos=ypos+(i-11)*(ListButton[i].height+6);
      }

    MSBPropertyButton(ListButton[i]).Parent=self;
  }
}

function bool checkOver(float X, float Y)
{
return false;
}
function MouseOver(Canvas C);

function LeftBtn(Canvas C)
{
super.LeftBtn(C);
LeftBtnFinished(C);
}

function AssignPoseToButton(MSBPropertyButton myButton,int PoseNumber)
{
local int i;

for (i=0;i<ListButton.length;i++)
  if (myButton==ListButton[i])
    MSBPawn(Parent).PoseName[i]=M.SavePoses[PoseNumber];
Log(M.SavePoses[PoseNumber]);
}

//function deSelect()                      //destroys all subButtons
//{
//local int i;
//super.deSelect();
//
//for (i=0;i<ListButton.Length;i++)
//  {
//  if (ListButton[i]!=None)
//    {
//    ListButton[i].deSelect();
//    M.myHUD.RemoveHudOverlay(ListButton[i]);
//    ListButton[i].Destroy();
//    }
//  }
//}

defaultproperties
{
ButtonList(0)="MSBPropertyButtons.MSBPropertyButtonPoseList";
ButtonList(1)="MSBPropertyButtons.MSBPropertyButtonPoseList";
ButtonList(2)="MSBPropertyButtons.MSBPropertyButtonPoseList";
ButtonList(3)="MSBPropertyButtons.MSBPropertyButtonPoseList";
ButtonList(4)="MSBPropertyButtons.MSBPropertyButtonPoseList";
ButtonList(5)="MSBPropertyButtons.MSBPropertyButtonPoseList";
ButtonList(6)="MSBPropertyButtons.MSBPropertyButtonPoseList";
ButtonList(7)="MSBPropertyButtons.MSBPropertyButtonPoseList";
ButtonList(8)="MSBPropertyButtons.MSBPropertyButtonPoseList";
ButtonList(9)="MSBPropertyButtons.MSBPropertyButtonPoseList";
ButtonList(10)="MSBPropertyButtons.MSBPropertyButtonPoseList";
ButtonList(11)="MSBPropertyButtons.MSBPropertyButtonPoseList";
ButtonList(12)="MSBPropertyButtons.MSBPropertyButtonPoseList";
ButtonList(13)="MSBPropertyButtons.MSBPropertyButtonPoseList";
ButtonList(14)="MSBPropertyButtons.MSBPropertyButtonPoseList";
ButtonList(15)="MSBPropertyButtons.MSBPropertyButtonPoseList";
xPos=512
yPos=256
width=256
height=256
Mat=pad_Icon
}


