//-----------------------------------------------------------
//
//-----------------------------------------------------------
class MSBMasterSelectButton extends MSBTwoStepButton;

#exec texture Import File=Textures\setMaster.tga Name=setMaster_Icon Mips=Off Alpha=1

var MSBVoxelEdController CC;

event PostBeginPlay()
{
super.PostBeginPlay();
CC=MSBVoxelEdController(M);
}

function LeftBtnFinished(Canvas C)
{
local vector gridLoc;
super.LeftBtnFinished(C);
if (Mouse.worldMSBTargetActor.IsA('MSBMasterBlock'))
  {
  CC.Master=MSBMasterBlock(Mouse.worldMSBTargetActor);
  CC.DrawBrush.Master=CC.Master;
  gridLoc=CC.Master.Location;
  CC.calculateGrid(gridLoc);
  CC.DrawBrush.SetLocation(gridLoc);
  CC.DrawBrush.SetRotation(CC.Master.Rotation);
  }
}

DefaultProperties
{
tooltip1="Set Master Block"
tooltip2="Select Master Block"
Mat=setMaster_Icon
}
